/*--------------------------------
------Case Statements
--------------------------------*/

--Most Basic Example
SELECT STU.ID,
       STU.GR,
       CASE WHEN STU.GR = '12' THEN 'Yes'
            ELSE 'No' END AS Is_A_Senior
  FROM STU


--Translating Race and Ethnicity to Descriptions for data extract
select CASE	WHEN STU.ETH = 'Y'
		THEN 'Hispanic'
	WHEN STU.ETH = 'N' AND STU.RC1 = '100' AND STU.RC2 = ''
		THEN 'American Indian OR Alaskan Native'
	WHEN STU.ETH = 'N' AND STU.RC1 IN ('201', '202', '203', '204', '205', '206', '207', '208', '299') AND
			(STU.RC2 = '' OR STU.RC2 IN ('201', '202', '203', '204', '205', '206', '207', '208', '299')) AND
			(STU.RC3 = '' OR STU.RC3 IN ('201', '202', '203', '204', '205', '206', '207', '208', '299')) AND
			(STU.RC4 = '' OR STU.RC4 IN ('201', '202', '203', '204', '205', '206', '207', '208', '299')) AND
			(STU.RC5 = '' OR STU.RC5 IN ('201', '202', '203', '204', '205', '206', '207', '208', '299'))
		THEN 'Asian'
	WHEN STU.ETH = 'N' 	AND STU.RC1 IN ('301', '302', '303', '304', '399') AND
			(STU.RC2 = '' OR STU.RC2 IN ('301', '302', '303', '304', '399')) AND
			(STU.RC3 = '' OR STU.RC3 IN ('301', '302', '303', '304', '399')) AND
			(STU.RC4 = '' OR STU.RC4 IN ('301', '302', '303', '304', '399')) AND
			(STU.RC5 = '' OR STU.RC5 IN ('301', '302', '303', '304', '399'))
		THEN 'Pacific Islander'
	WHEN STU.ETH = 'N' AND STU.RC1 = '400' AND STU.RC2 = ''
		THEN 'Filipino'
	WHEN STU.ETH = 'N' AND STU.RC1 = '600' AND STU.RC2 = ''
		THEN 'African American'
	WHEN STU.ETH = 'N' AND STU.RC1 = '700' AND STU.RC2 = ''
		THEN 'White'
	WHEN STU.ETH = 'N' AND STU.RC1 <> '' AND STU.RC2 <> ''
		THEN '2 or More Races'
		ELSE 'Unknown'
	END AS [Ethnicity], *
	from STU