/*--------------------------------
------Fun SQL Tricks for Aeries
--------------------------------*/

--Determine Graduation Year
SELECT ID, GR,'20' + SUBSTRING(db_name(),4,2) +(13-gr) AS [GradYear]
FROM STU

-- Logged in Users for all databases on server
SELECT 
    DB_NAME(dbid) as DBName, 
    COUNT(dbid) as NumberOfConnections,
    loginame as LoginName
FROM
    sys.sysprocesses
WHERE 
    dbid > 0
GROUP BY 
    dbid, loginame

--Schema column info
SELECT * FROM INFORMATION_SCHEMA.COLUMNS
WHERE COLUMN_NAME LIKE '%id%'
ORDER BY TABLE_NAME

--Get Description -- still running 
SELECT SC, ID, LF, 
dbo.Get_Description(0,'STU','LF',LF) AS LF_Description,
PED,
dbo.Get_Description(0,'STU','PED',PED) AS PED_Description,
HL,
dbo.Get_Description(0,'STU','HL',HL) AS HL_Description
FROM STU
WHERE DEL = 0 

--Get Description_New runs SO much faster
SELECT SC, ID, LF, 
[GetDescr_STU_LF].DE AS LF_Description,
PED,
[GetDescr_STU_PED].DE AS PED_Description,
HL,
[GetDescr_STU_HL].DE AS HL_Description
FROM STU
  CROSS APPLY dbo.Get_Description_New(0, 'STU', 'LF', LF) AS [GetDescr_STU_LF]  
  CROSS APPLY dbo.Get_Description_New(0, 'STU', 'PED', PED) AS [GetDescr_STU_PED] 
  CROSS APPLY dbo.Get_Description_New(0, 'STU', 'HL', HL) AS [GetDescr_STU_HL] 
WHERE STU.DEL = 0

