/*--------------------------------
------ Joins
--------------------------------*/

-- Only display students with a particular test score
SELECT STU.SC, STU.ID, STU.LN, STU.FN, TST.PT, TST.OT, TST.TD
FROM STU 
INNER JOIN TST ON STU.ID = TST.PID
WHERE TST.ID = 'CELDT'
  AND TST.PT = 1 
  AND TST.OT < 3 
  AND TST.TD = '11/1/2019'



--Portal Account Percentages
SELECT STU.SC, LOC.NM, COUNT(*) AS TotalStudents,
(SELECT COUNT(DISTINCT S1.ID) 
FROM STU AS S1 
LEFT JOIN PWS on PWS.ID = S1.ID 
LEFT JOIN PWA on PWA.AID = PWS.AID 
WHERE PWA.DEL = 0 AND PWS.DEL = 0 AND S1.DEL = 0 AND RTRIM(S1.TG) = '' AND S1.SC = STU.SC) AS TotalWithAccounts,
CAST(CAST(ROUND((CAST((SELECT COUNT(DISTINCT S1.ID) 
FROM STU AS S1 
LEFT JOIN PWS on PWS.ID = S1.ID 
LEFT JOIN PWA on PWA.AID = PWS.AID 
WHERE PWA.DEL = 0 AND PWS.DEL = 0 AND S1.DEL = 0 AND RTRIM(S1.TG) = '' AND S1.SC = STU.SC) AS DECIMAL)/CAST(COUNT(*)AS DECIMAL) * 100),2) AS DECIMAL(10,2)) AS VARCHAR(10))+'%' AS PercentwithAccounts,
CAST(CAST(ROUND(abs((CAST((SELECT COUNT(DISTINCT S1.ID) 
FROM STU AS S1 
LEFT JOIN PWS on PWS.ID = S1.ID 
LEFT JOIN PWA on PWA.AID = PWS.AID 
WHERE PWA.DEL = 0 AND PWS.DEL = 0 AND S1.DEL = 0 AND RTRIM(S1.TG) = '' AND S1.SC = STU.SC) AS DECIMAL)/CAST(COUNT(*)AS DECIMAL) * 100) - 100),2) AS DECIMAL(10,2)) AS VARCHAR(10))+'%' AS PercentwithoutAccounts,
(SELECT COUNT(DISTINCT S1.ID)
FROM STU AS S1 
LEFT JOIN PWS on PWS.ID = S1.ID 
LEFT JOIN PWA on PWA.AID = PWS.AID 
WHERE PWA.DEL = 0 AND PWA.TY = 'P' AND PWS.DEL = 0 AND S1.DEL = 0 AND RTRIM(S1.TG) = '' AND S1.SC = STU.SC) AS TotalWithParentAccounts,
CAST(CAST(ROUND((CAST((SELECT COUNT(DISTINCT S1.ID) 
FROM STU AS S1 
LEFT JOIN PWS on PWS.ID = S1.ID 
LEFT JOIN PWA on PWA.AID = PWS.AID 
WHERE PWA.DEL = 0 AND PWA.TY = 'P' AND PWS.DEL = 0 AND S1.DEL = 0 AND RTRIM(S1.TG) = '' AND S1.SC = STU.SC) AS DECIMAL)/CAST(COUNT(*)AS DECIMAL) * 100),2) AS DECIMAL(10,2)) AS VARCHAR(10))+'%' AS PercentwithParentAccounts,
CAST(CAST(ROUND(abs((CAST((SELECT COUNT(DISTINCT S1.ID) 
FROM STU AS S1 
LEFT JOIN PWS on PWS.ID = S1.ID 
LEFT JOIN PWA on PWA.AID = PWS.AID 
WHERE PWA.DEL = 0 AND PWA.TY = 'P' AND PWS.DEL = 0 AND S1.DEL = 0 AND RTRIM(S1.TG) = '' AND S1.SC = STU.SC) AS DECIMAL)/CAST(COUNT(*)AS DECIMAL) * 100) - 100),2) AS DECIMAL(10,2)) AS VARCHAR(10))+'%' AS PercentwithoutParentAccounts,
(SELECT COUNT(DISTINCT S1.ID) 
FROM STU AS S1 
LEFT JOIN PWS on PWS.ID = S1.ID 
LEFT JOIN PWA on PWA.AID = PWS.AID 
WHERE PWA.DEL = 0 AND PWA.TY = 'S' AND PWS.DEL = 0 AND S1.DEL = 0 AND RTRIM(S1.TG) = '' AND S1.SC = STU.SC) AS TotalWithStudentAccounts,
CAST(CAST(ROUND((CAST((SELECT COUNT(DISTINCT S1.ID) 
FROM STU AS S1 
LEFT JOIN PWS on PWS.ID = S1.ID 
LEFT JOIN PWA on PWA.AID = PWS.AID 
WHERE PWA.DEL = 0 AND PWA.TY = 'S' AND PWS.DEL = 0 AND S1.DEL = 0 AND RTRIM(S1.TG) = '' AND S1.SC = STU.SC) AS DECIMAL)/CAST(COUNT(*)AS DECIMAL) * 100),2) AS DECIMAL(10,2)) AS VARCHAR(10))+'%' AS PercentwithStudentAccounts,
CAST(CAST(ROUND(abs((CAST((SELECT COUNT(DISTINCT S1.ID) 
FROM STU AS S1 
LEFT JOIN PWS on PWS.ID = S1.ID 
LEFT JOIN PWA on PWA.AID = PWS.AID 
WHERE PWA.DEL = 0 AND PWA.TY = 'S' AND PWS.DEL = 0 AND S1.DEL = 0 AND RTRIM(S1.TG) = '' AND S1.SC = STU.SC) AS DECIMAL)/CAST(COUNT(*)AS DECIMAL) * 100) - 100),2) AS DECIMAL(10,2)) AS VARCHAR(10))+'%' AS PercentwithoutSTUdentAccounts
FROM STU LEFT JOIN LOC on STU.SC = LOC.CD
WHERE RTRIM(STU.TG) = '' AND STU.DEL = 0
group by STU.SC, LOC.NM
order by STU.SC