/*--------------------------------
------ Subqueries
--------------------------------*/


-- Only display students with a particular test score
SELECT STU.SC, STU.ID, STU.LN, STU.FN
FROM STU 
WHERE ID IN 
(SELECT PID FROM TST WHERE DEL = 0
  AND ID = 'CELDT' 
  AND PT = 1 
  AND OT < 3 
  AND TD = '11/1/2019')


--Display PWA records that have more than 3 students associated with it.
SELECT PWA.* 
FROM PWA
WHERE DEL = 0 AND AID IN (SELECT AID FROM PWS WHERE DEL = 0 GROUP BY AID HAVING COUNT(*) > 3)


--Displaying STU records for an associated PWA email address.
SELECT SC, ID, LN, FN, SEM, PG, CASE WHEN LEN(TL) = 10 THEN '(' + LEFT(TL, 3) + ') ' + SUBSTRING(TL, 4, 3) + '-' + RIGHT(TL, 4) END
FROM STU
WHERE DEL = 0 AND ID IN (SELECT ID FROM PWS WHERE DEL = 0 AND AID IN (SELECT AID FROM PWA WHERE DEL = 0 AND EM = 'student193@aeries.com'))


--Subquery to pull the description from the COD table
SELECT LF, (SELECT DE FROM COD AS subCOD WHERE subCOD.TC = 'STU' AND subCOD.FC = 'LF' AND STU.LF = subCOD.CD) 'Description' FROM STU
--I'll show another way to do this later

/*
Sub queries to return data when it exists using ISNULL()
The syntax for the ISNULL function in SQL Server (Transact-SQL) is:
ISNULL( expression, alternative_value ) In this case we are using our subquery as the expression
*/
SELECT STU.ID AS LocalID,
       STU.CID AS SSID,
	   REPLACE(STU.LN, ',', ' ') AS LastName,
       REPLACE(STU.FN, ',', ' ') AS FirstName,
       REPLACE(STU.MN, ',', ' ') AS MiddleName,
	   LSI.LLN,
	   LSI.LFN,
	   LSI.LMN,
	   isnull((select lsi.LLN from lsi where lsi.id = stu.id),stu.ln)[LastName],
	   isnull((select lsi.LFN from lsi where lsi.id = stu.id),stu.fn)[FirstName],
	   isnull((select lsi.LMN from lsi where lsi.id = stu.id),stu.mn)[MiddleName]

FROM STU LEFT JOIN LSI on STU.ID = LSI.ID
WHERE STU.DEL = 0 AND STU.LN <> '_' AND STU.TG IN ('')
ORDER BY STU.LN, STU.FN


--INSERT LSI (ID,LFN,LLN,LMN)
--VALUES (99000001,'Homer','Simpson','J')