/*--------------------------------
Window Functions using Partition By
--------------------------------*/

--Average by Grade Level
SELECT GR, AVG(ClassSize) AS AvgClassSize
FROM (	SELECT DISTINCT GR,
			COUNT(GR) OVER (PARTITION BY GR) AS ClassSize
		FROM STU
		WHERE DEL = 0 AND TG = '') A
GROUP BY GR 
ORDER BY GR

---Grade level averages by school
SELECT SC, GR, AVG(ClassSize) AS AvgClassSize
FROM (	SELECT DISTINCT SC, GR,
			COUNT(GR) OVER (PARTITION BY SC, GR) AS ClassSize
		FROM STU
		WHERE DEL = 0 AND TG = '') A
GROUP BY SC, GR
ORDER BY SC, GR

--RANK by Grade
SELECT
  RANK() OVER (PARTITION BY STU.GR ORDER BY STU.TP DESC)
    AS STU_RANK,
	STU.TP,
	STU.GR,
	STU.ID,
	STU.LN,
	STU.FN
FROM STU WHERE STU.SC = 994 --AND STU.TP > 0
ORDER BY STU_RANK, STU.GR

--RANK by School Code by Grade
SELECT
    STU.SC,
  RANK() OVER (PARTITION BY STU.SC, STU.GR ORDER BY STU.TP DESC)
    AS STU_RANK,
	STU.TP,
	STU.GR,
	STU.ID,
	STU.LN,
	STU.FN
FROM STU WHERE STU.TP > 0
ORDER BY STU.SC, STU_RANK, STU.GR

--Using ROWNUMBER with Partition By becomes even more powerful
SELECT 
  STU.SC, 
  STU.SN,
  STU.LN,
  STU.FN,
  ROW_NUMBER() OVER (PARTITION BY SC ORDER BY LN)
FROM STU

--Using Partition By to Insert HIS
Advanced IT Day content in Freshdesk


--INSERT HIS
SELECT PID, CN, MK, CR, GR, TE, YR, CO, ST, CC, RT, CI, 
row_number() over ( partition by pid order by sq ) + isnull((select max(sq) from his[h] where h.pid = his.pid),0) AS NewSQ
, EN, PR, TD, AB, EA, UA, SU, SE, SID, HR, SRC, SDE, ABG, DC, PF, CH, AC, SA, AMK, MAG, MAA, SSC, DEL, DTS
FROM  DST22000AeriesDemo.dbo.HIS
WHERE (GR = 8) 
AND (YR = 22)
AND (ST = 993)
AND (TE = 1)




